/*
A Video Attendance Module
Copyright (C) Slot 6:Group 2:Reebhu,Keshav,Ayush,Kshitij

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
*/

#pragma once

/*External Libraries*/
#include<iostream>
#include<opencv2\core\core.hpp>
#include<stdlib.h>

/*Header files*/
#include"Main.h"

namespace VAM {

	/*Namespaces*/
	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;

		public ref class Settings : public System::Windows::Forms::Form
		{
		public:
			/*constructor*/
			Settings(void)
			{
				/*init*/
				InitializeComponent();
			}

		protected:
			/*destructor*/
			~Settings()
			{
				if (components)
				{
					delete components;
				}
			}
		private: System::Windows::Forms::TrackBar^  trackBar1;
		private: System::Windows::Forms::TrackBar^  trackBar2;
		private: System::Windows::Forms::Label^  label1;
		private: System::Windows::Forms::TrackBar^  trackBar3;
		private: System::Windows::Forms::Label^  label2;
		private: System::Windows::Forms::Label^  label3;
		private: System::Windows::Forms::Label^  label4;
		private: System::Windows::Forms::Label^  label5;
		private: System::Windows::Forms::Label^  label6;
		private:
			/*Component initializer*/
			System::ComponentModel::Container ^components;

	#pragma region Windows Form Designer generated code
			/*Initializer function definition*/
			void InitializeComponent(void)
			{
				this->trackBar1 = (gcnew System::Windows::Forms::TrackBar());
				this->trackBar2 = (gcnew System::Windows::Forms::TrackBar());
				this->label1 = (gcnew System::Windows::Forms::Label());
				this->trackBar3 = (gcnew System::Windows::Forms::TrackBar());
				this->label2 = (gcnew System::Windows::Forms::Label());
				this->label3 = (gcnew System::Windows::Forms::Label());
				this->label4 = (gcnew System::Windows::Forms::Label());
				this->label5 = (gcnew System::Windows::Forms::Label());
				this->label6 = (gcnew System::Windows::Forms::Label());
				(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->trackBar1))->BeginInit();
				(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->trackBar2))->BeginInit();
				(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->trackBar3))->BeginInit();
				this->SuspendLayout();
				// 
				// trackBar1
				// 
				this->trackBar1->Location = System::Drawing::Point(452, 77);
				this->trackBar1->Maximum = 20;
				this->trackBar1->Minimum = 5;
				this->trackBar1->Name = L"trackBar1";
				this->trackBar1->Size = System::Drawing::Size(187, 56);
				this->trackBar1->TabIndex = 0;
				this->trackBar1->Value = __Num_Photos;
				this->trackBar1->Scroll += gcnew System::EventHandler(this, &Settings::trackBar1_Scroll);
				// 
				// trackBar2
				// 
				this->trackBar2->Location = System::Drawing::Point(452, 192);
				this->trackBar2->Maximum = 50;
				this->trackBar2->Minimum = 5;
				this->trackBar2->Name = L"trackBar2";
				this->trackBar2->Size = System::Drawing::Size(187, 56);
				this->trackBar2->TabIndex = 1;
				this->trackBar2->Value = __Num_Eigenfaces;
				this->trackBar2->Scroll += gcnew System::EventHandler(this, &Settings::trackBar2_Scroll);
				// 
				// label1
				// 
				this->label1->AutoSize = true;
				this->label1->Font = (gcnew System::Drawing::Font(L"Comic Sans MS", 12, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
					static_cast<System::Byte>(0)));
				this->label1->Location = System::Drawing::Point(60, 77);
				this->label1->Name = L"label1";
				this->label1->Size = System::Drawing::Size(243, 28);
				this->label1->TabIndex = 15;
				this->label1->Text = L"No Of Pictures(Training)";
				// 
				// trackBar3
				// 
				this->trackBar3->Location = System::Drawing::Point(452, 296);
				this->trackBar3->Maximum = 1500;
				this->trackBar3->Minimum = 700;
				this->trackBar3->Name = L"trackBar3";
				this->trackBar3->Size = System::Drawing::Size(187, 56);
				this->trackBar3->TabIndex = 16;
				this->trackBar3->Value = __Threshold;
				this->trackBar3->Scroll += gcnew System::EventHandler(this, &Settings::trackBar3_Scroll);
				// 
				// label2
				// 
				this->label2->AutoSize = true;
				this->label2->Font = (gcnew System::Drawing::Font(L"Comic Sans MS", 12, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
					static_cast<System::Byte>(0)));
				this->label2->Location = System::Drawing::Point(112, 192);
				this->label2->Name = L"label2";
				this->label2->Size = System::Drawing::Size(96, 28);
				this->label2->TabIndex = 17;
				this->label2->Text = L"Number of __Num_Eigenfaces";
				// 
				// label3
				// 
				this->label3->AutoSize = true;
				this->label3->Font = (gcnew System::Drawing::Font(L"Comic Sans MS", 12, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
					static_cast<System::Byte>(0)));
				this->label3->Location = System::Drawing::Point(95, 296);
				this->label3->Name = L"label3";
				this->label3->Size = System::Drawing::Size(113, 28);
				this->label3->TabIndex = 18;
				this->label3->Text = L"__Threshold of Output";
				// 
				// label4
				// 
				this->label4->AutoSize = true;
				this->label4->Location = System::Drawing::Point(656, 77);
				this->label4->Name = L"label4";
				this->label4->Size = System::Drawing::Size(24, 17);
				this->label4->TabIndex = 19;
				System::String^ _tmp = gcnew System::String(to_string(__Num_Photos).c_str());
				this->label4->Text = _tmp;
				// 
				// label5
				// 
				this->label5->AutoSize = true;
				this->label5->Location = System::Drawing::Point(656, 192);
				this->label5->Name = L"label5";
				this->label5->Size = System::Drawing::Size(36, 17);
				this->label5->TabIndex = 20;
				_tmp = gcnew System::String(to_string(__Num_Eigenfaces).c_str());
				this->label5->Text = _tmp;
				// 
				// label6
				// 
				this->label6->AutoSize = true;
				this->label6->Location = System::Drawing::Point(656, 307);
				this->label6->Name = L"label6";
				this->label6->Size = System::Drawing::Size(36, 17);
				this->label6->TabIndex = 21;
				_tmp = gcnew System::String(to_string(__Threshold).c_str());
				this->label6->Text = _tmp;
				// 
				// Settings
				// 
				this->AutoScaleDimensions = System::Drawing::SizeF(8, 16);
				this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
				this->ClientSize = System::Drawing::Size(766, 411);
				this->Controls->Add(this->label6);
				this->Controls->Add(this->label5);
				this->Controls->Add(this->label4);
				this->Controls->Add(this->label3);
				this->Controls->Add(this->label2);
				this->Controls->Add(this->trackBar3);
				this->Controls->Add(this->label1);
				this->Controls->Add(this->trackBar2);
				this->Controls->Add(this->trackBar1);
				this->Name = L"Settings";
				this->Text = L"Settings";
				(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->trackBar1))->EndInit();
				(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->trackBar2))->EndInit();
				(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->trackBar3))->EndInit();
				this->ResumeLayout(false);
				this->PerformLayout();

			}
	#pragma endregion
		private: System::Void trackBar1_Scroll(System::Object^  sender, System::EventArgs^  e) 
		{
			/*Trackbar1:Num Photos controller*/
			int value = trackBar1->Value;
			__Num_Photos = value;
			System::String^ temp = gcnew System::String(to_string(value).c_str());
			label4->Text = temp;
		}
		private: System::Void trackBar2_Scroll(System::Object^  sender, System::EventArgs^  e)
		{
			/*Trackbar2:Eigenfaces controller*/
			int value = trackBar2->Value;
			__Num_Eigenfaces = value;
			System::String^ temp = gcnew System::String(to_string(value).c_str());
			label5->Text = temp;
		}
		private: System::Void trackBar3_Scroll(System::Object^  sender, System::EventArgs^  e)
		{
			/*Trackbar3:Threshold Controller*/
			int value = trackBar3->Value;
			__Threshold = value;
			System::String^ temp = gcnew System::String(to_string(value).c_str());
			label6->Text = temp;
		}
	};
}
