/*
A Video Attendance Module
Copyright (C) Slot 6:Group 2:Reebhu,Keshav,Ayush,Kshitij

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
*/

#pragma once

/*
* OpenCV Library Headers
*/
#include "opencv/cv.h"
#include "opencv/highgui.h"
#include "opencv2/core/core.hpp"
#include "opencv2/opencv.hpp"

/*
* Included Header Files
*/
#include "Login.h"
#include "Detect.h"

namespace VAM {

	/*Namespaces cv,std*/
	using namespace cv;
	using namespace std;
	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;

	/*
	* The video attendance class
	*/
	public ref class VideoAttendance : public System::Windows::Forms::Form
	{
	public:
		/*The default constructor*/
		VideoAttendance(void)
		{
			/*Initialize component*/
			InitializeComponent();
		}

	protected:
		/*Destructor */
		~VideoAttendance()
		{
			if (components)
			{
				delete components;
			}
		}

		/*
		* The form components
		*/
	private: System::Windows::Forms::Button^  button1;
	private: System::Windows::Forms::Button^  button3;
	private: System::Windows::Forms::RadioButton^  radioButton1;
	private: System::Windows::Forms::RadioButton^  radioButton2;
	private: System::Windows::Forms::Label^  label1;
	private: System::Windows::Forms::PictureBox^  pictureBox2;
	private: System::Windows::Forms::Label^  label2;
	private: System::Windows::Forms::Label^  label3;
	private: System::Windows::Forms::Timer^  timer1;
	private: System::Windows::Forms::Label^  label4;
	private: System::Windows::Forms::Panel^  panel1;
	private: System::ComponentModel::BackgroundWorker^  backgroundWorker1;
	private: System::ComponentModel::IContainer^  components;

#pragma region Windows Form Designer generated code

			 /*
			 * This is the function called in constructor, to initialize components
			 */
			 void InitializeComponent(void)
			 {
				 this->components = (gcnew System::ComponentModel::Container());
				 this->button1 = (gcnew System::Windows::Forms::Button());
				 this->button3 = (gcnew System::Windows::Forms::Button());
				 this->radioButton1 = (gcnew System::Windows::Forms::RadioButton());
				 this->radioButton2 = (gcnew System::Windows::Forms::RadioButton());
				 this->label1 = (gcnew System::Windows::Forms::Label());
				 this->pictureBox2 = (gcnew System::Windows::Forms::PictureBox());
				 this->label2 = (gcnew System::Windows::Forms::Label());
				 this->label3 = (gcnew System::Windows::Forms::Label());
				 this->timer1 = (gcnew System::Windows::Forms::Timer(this->components));
				 this->label4 = (gcnew System::Windows::Forms::Label());
				 this->panel1 = (gcnew System::Windows::Forms::Panel());
				 this->backgroundWorker1 = (gcnew System::ComponentModel::BackgroundWorker());
				 (cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->pictureBox2))->BeginInit();
				 this->panel1->SuspendLayout();
				 this->SuspendLayout();
				 // 
				 // button1
				 // 
				 this->button1->Location = System::Drawing::Point(1059, 38);
				 this->button1->Name = L"button1";
				 this->button1->Size = System::Drawing::Size(129, 36);
				 this->button1->TabIndex = 1;
				 this->button1->Text = L"Admin";
				 this->button1->UseVisualStyleBackColor = true;
				 this->button1->Click += gcnew System::EventHandler(this, &VideoAttendance::button1_Click);
				 // 
				 // button3
				 // 
				 this->button3->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 9, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point,
					 static_cast<System::Byte>(0)));
				 this->button3->Location = System::Drawing::Point(529, 706);
				 this->button3->Name = L"button3";
				 this->button3->Size = System::Drawing::Size(129, 40);
				 this->button3->TabIndex = 3;
				 this->button3->Text = L"Exit";
				 this->button3->UseVisualStyleBackColor = true;
				 this->button3->Click += gcnew System::EventHandler(this, &VideoAttendance::button3_Click);
				 // 
				 // radioButton1
				 // 
				 this->radioButton1->AutoSize = true;
				 this->radioButton1->Checked = true;
				 this->radioButton1->Font = (gcnew System::Drawing::Font(L"Comic Sans MS", 12, System::Drawing::FontStyle::Italic, System::Drawing::GraphicsUnit::Point,
					 static_cast<System::Byte>(0)));
				 this->radioButton1->Location = System::Drawing::Point(34, 280);
				 this->radioButton1->Name = L"radioButton1";
				 this->radioButton1->Size = System::Drawing::Size(150, 33);
				 this->radioButton1->TabIndex = 4;
				 this->radioButton1->TabStop = true;
				 this->radioButton1->Text = L"Static Mode";
				 this->radioButton1->UseVisualStyleBackColor = true;
				 // 
				 // radioButton2
				 // 
				 this->radioButton2->AutoSize = true;
				 this->radioButton2->Font = (gcnew System::Drawing::Font(L"Comic Sans MS", 12, System::Drawing::FontStyle::Italic, System::Drawing::GraphicsUnit::Point,
					 static_cast<System::Byte>(0)));
				 this->radioButton2->Location = System::Drawing::Point(34, 427);
				 this->radioButton2->Name = L"radioButton2";
				 this->radioButton2->Size = System::Drawing::Size(199, 33);
				 this->radioButton2->TabIndex = 5;
				 this->radioButton2->TabStop = true;
				 this->radioButton2->Text = L"Attendance Mode";
				 this->radioButton2->UseVisualStyleBackColor = true;
				 // 
				 // label1
				 // 
				 this->label1->AutoSize = true;
				 this->label1->Font = (gcnew System::Drawing::Font(L"Comic Sans MS", 16.2F, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point,
					 static_cast<System::Byte>(0)));
				 this->label1->Location = System::Drawing::Point(449, 35);
				 this->label1->Name = L"label1";
				 this->label1->Size = System::Drawing::Size(276, 39);
				 this->label1->TabIndex = 6;
				 this->label1->Text = L"Welcome to CS101";
				 // 
				 // pictureBox2
				 // 
				 this->pictureBox2->Location = System::Drawing::Point(269, 129);
				 this->pictureBox2->Name = L"pictureBox2";
				 this->pictureBox2->Size = System::Drawing::Size(656, 532);
				 this->pictureBox2->TabIndex = 7;
				 this->pictureBox2->TabStop = false;
				 // 
				 // label2
				 // 
				 this->label2->Location = System::Drawing::Point(0, 0);
				 this->label2->Name = L"label2";
				 this->label2->Size = System::Drawing::Size(100, 23);
				 this->label2->TabIndex = 1;
				 // 
				 // label3
				 // 
				 this->label3->Location = System::Drawing::Point(0, 0);
				 this->label3->Name = L"label3";
				 this->label3->Size = System::Drawing::Size(100, 23);
				 this->label3->TabIndex = 0;
				 // 
				 // timer1
				 // 
				 this->timer1->Interval = 50;
				 this->timer1->Tick += gcnew System::EventHandler(this, &VideoAttendance::timer1_Tick);
				 // 
				 // label4
				 // 
				 this->label4->AutoSize = true;
				 this->label4->Font = (gcnew System::Drawing::Font(L"Comic Sans MS", 12, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point,
					 static_cast<System::Byte>(0)));
				 this->label4->Location = System::Drawing::Point(29, 46);
				 this->label4->Name = L"label4";
				 this->label4->Size = System::Drawing::Size(177, 28);
				 this->label4->TabIndex = 8;
				 this->label4->Text = L"DATE AND TIME";
				 // 
				 // panel1
				 // 
				 this->panel1->Controls->Add(this->button1);
				 this->panel1->Controls->Add(this->label4);
				 this->panel1->Controls->Add(this->pictureBox2);
				 this->panel1->Controls->Add(this->button3);
				 this->panel1->Controls->Add(this->label1);
				 this->panel1->Controls->Add(this->radioButton1);
				 this->panel1->Controls->Add(this->radioButton2);
				 this->panel1->Location = System::Drawing::Point(3, 0);
				 this->panel1->Name = L"panel1";
				 this->panel1->Size = System::Drawing::Size(1238, 873);
				 this->panel1->TabIndex = 9;
				 // 
				 // VideoAttendance
				 // 
				 this->AutoScaleDimensions = System::Drawing::SizeF(8, 16);
				 this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
				 this->ClientSize = System::Drawing::Size(1242, 773);
				 this->Controls->Add(this->label3);
				 this->Controls->Add(this->label2);
				 this->Controls->Add(this->panel1);
				 this->Name = L"VideoAttendance";
				 this->Text = L"VideoAttendance";
				 this->Load += gcnew System::EventHandler(this, &VideoAttendance::VideoAttendance_Load);
				 (cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->pictureBox2))->EndInit();
				 this->panel1->ResumeLayout(false);
				 this->panel1->PerformLayout();
				 this->ResumeLayout(false);

			 }

	public:
		/*Variable declarations needed within the class*/
		Mat *frame = new Mat;
		Mat *tmp_frame = new Mat;

		/*Capture from camera*/
		CvCapture*CamCap = cvCaptureFromCAM(0);

		/*datetime*/
		DateTime datetime;

		/*Height and Width of Frame*/
		int height, width;

		/*Resize ratios*/
		double ratioheight, ratiowidth;

		/*The login object*/
		Login ^login_module = gcnew Login;

	private: System::Void VideoAttendance_Load(System::Object^  sender, System::EventArgs^  e) {
		/*Read current student index*/
		ifstream InFile;
		InFile.open("stu_index.txt");
		InFile >> __Student_Current_Index;
		InFile.close();

		/*Start the timer*/
		timer1->Start();

		/*Open Students Storage*/
		cv::FileStorage fs("Students.yml", cv::FileStorage::READ);


		/*Height property of VideoAttendance Object*/
		height = VideoAttendance::Height;
		/*Width property of VideoAttendance Object*/
		width = VideoAttendance::Width;
	}

			 /*Function to execure on every timer tick*/
	private: System::Void timer1_Tick(System::Object^  sender, System::EventArgs^  e)
	{
		/*Check which mode we are in*/
		if (radioButton2->Checked)
		{
			cvSetCaptureProperty(CamCap, CV_CAP_PROP_SATURATION, 0);	//if we are in atendance mode
		}
		else
		{
			cvSetCaptureProperty(CamCap, CV_CAP_PROP_SATURATION, 69);	//if we are in static mode
		}

		/*Retrieve Frame*/
		*frame = cvRetrieveFrame(CamCap);

		if (radioButton2->Checked)
			attendance_modeify(frame);	//show frame with detected faces

		/*Make a temp frame to do resize*/
		*tmp_frame = frame->clone();

		//Resize to picture box
		resize(*frame, *tmp_frame, cv::Size(pictureBox2->Height, pictureBox2->Width), 0, 0, INTER_LINEAR);

		try
		{
			if (tmp_frame != NULL)
			{
				/*If Not Null*/
				IplImage* frame_image = cvCloneImage(&(IplImage)*tmp_frame);
				pictureBox2->Image = gcnew System::Drawing::Bitmap(frame_image->width, frame_image->height, frame_image->widthStep, System::Drawing::Imaging::PixelFormat::Format24bppRgb, (System::IntPtr)frame_image->imageData);
				pictureBox2->Refresh();
			}
			else
				throw "Resized Frame is null";
		}
		catch (const char* exception)
		{
			cout << exception << endl;
		}

		//Update datetime string
		label4->Text = datetime.Now.ToString();

		//delete image, takes up memory
		delete pictureBox2->Image;
	}

	private: System::Void button3_Click(System::Object^  sender, System::EventArgs^  e)
	{
		//Exit application
		Application::Exit();
	}

	private: System::Void button1_Click(System::Object^  sender, System::EventArgs^  e) {
		/*Show Login Module*/
		login_module->Show();
	}

	private: System::Void VideoAttendance_ResizeBegin(System::Object^  sender, System::EventArgs^  e) {
		//Resize Video Window
		panel1->Size = VideoAttendance::Size;
	}
	public: void attendance_modeify(Mat*frame)
	{
		/*Return modified frame with detected face*/
		videoFaceDetect2(frame);
	}
	};
}

#pragma endregion

